Package org.bukkit.entity

# Interface Allay

All Superinterfaces:
  `Attributable`, `Audience`, `CommandSender`, `Creature`, `Damageable`, `Entity`, `Frictional`, `HoverEventSource<HoverEvent.ShowEntity>`, `InventoryHolder`, `LivingEntity`, `Lootable`, `Metadatable`, `Mob`, `Nameable`, `Permissible`, `PersistentDataHolder`, `Pointered`, `ProjectileSource`, `ServerOperator`, `Sound.Emitter`

public interface Allay extends Creature, InventoryHolder
An Allay.

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.bukkit.entity.Entity

`Entity.Spigot`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canDuplicate()`
Gets if the allay can duplicate.
`@Nullable Allay`
`duplicateAllay()`
This make the current allay duplicate itself without dance or item necessary.
`long`
`getDuplicationCooldown()`
Gets the cooldown for duplicating the allay.
`@Nullable Location`
`getJukebox()`
Gets the jukebox the allay is set to dance to.
`boolean`
`isDancing()`
Gets if the allay is dancing.
`void`
`resetDuplicationCooldown()`
Reset the cooldown for duplication.
`void`
`setCanDuplicate(boolean canDuplicate)`
Sets if the allay can duplicate.
`void`
`setDuplicationCooldown(long cooldown)`
Sets the cooldown before the allay can duplicate again.
`void`
`startDancing()`
Force sets the dancing status of the allay.
`void`
`startDancing(@NotNull Location location)`
Causes the allay to start dancing because of the provided jukebox location.
`void`
`stopDancing()`
Makes the allay stop dancing.

### Methods inherited from interface org.bukkit.attribute.Attributable

`getAttribute, registerAttribute`

### Methods inherited from interface net.kyori.adventure.audience.Audience

`clearTitle, deleteMessage, deleteMessage, filterAudience, forEachAudience, hideBossBar, openBook, openBook, playSound, playSound, playSound, resetTitle, sendActionBar, sendActionBar, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendPlayerListFooter, sendPlayerListFooter, sendPlayerListHeader, sendPlayerListHeader, sendPlayerListHeaderAndFooter, sendPlayerListHeaderAndFooter, sendTitlePart, showBossBar, showTitle, stopSound, stopSound`

### Methods inherited from interface org.bukkit.command.CommandSender

`getName, name, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendMessage, sendPlainMessage, sendRichMessage`

### Methods inherited from interface org.bukkit.entity.Damageable

`damage, damage, getAbsorptionAmount, getHealth, getMaxHealth, resetMaxHealth, setAbsorptionAmount, setHealth, setMaxHealth`

### Methods inherited from interface org.bukkit.entity.Entity

`addPassenger, addScoreboardTag, asHoverEvent, collidesAt, eject, fromMobSpawner, getBoundingBox, getChunk, getEntityId, getEntitySpawnReason, getFacing, getFallDistance, getFireTicks, getFreezeTicks, getHeight, getLastDamageCause, getLocation, getLocation, getMaxFireTicks, getMaxFreezeTicks, getNearbyEntities, getOrigin, getPassenger, getPassengers, getPistonMoveReaction, getPortalCooldown, getPose, getScoreboardTags, getServer, getSpawnCategory, getSwimHighSpeedSplashSound, getSwimSound, getSwimSplashSound, getTicksLived, getTrackedPlayers, getType, getUniqueId, getVehicle, getVelocity, getWidth, getWorld, hasGravity, isCustomNameVisible, isDead, isEmpty, isFreezeTickingLocked, isFrozen, isGlowing, isInBubbleColumn, isInLava, isInPowderedSnow, isInRain, isInsideVehicle, isInvulnerable, isInWater, isInWaterOrBubbleColumn, isInWaterOrRain, isInWaterOrRainOrBubbleColumn, isOnGround, isPersistent, isSilent, isTicking, isUnderWater, isValid, isVisualFire, leaveVehicle, lockFreezeTicks, playEffect, remove, removePassenger, removeScoreboardTag, setCustomNameVisible, setFallDistance, setFireTicks, setFreezeTicks, setGlowing, setGravity, setInvulnerable, setLastDamageCause, setPassenger, setPersistent, setPortalCooldown, setRotation, setSilent, setTicksLived, setVelocity, setVisualFire, spawnAt, spawnAt, spigot, teamDisplayName, teleport, teleport, teleport, teleport, teleport, teleport, teleport, teleport, teleportAsync, teleportAsync, wouldCollideUsing`

### Methods inherited from interface io.papermc.paper.entity.Frictional

`getFrictionState, setFrictionState`

### Methods inherited from interface net.kyori.adventure.text.event.HoverEventSource

`asHoverEvent`

### Methods inherited from interface org.bukkit.inventory.InventoryHolder

`getInventory`

### Methods inherited from interface org.bukkit.entity.LivingEntity

`addPotionEffect, addPotionEffect, addPotionEffects, attack, broadcastSlotBreak, broadcastSlotBreak, canBreatheUnderwater, clearActiveItem, damageItemStack, damageItemStack, getActiveItem, getActivePotionEffects, getArrowCooldown, getArrowsInBody, getArrowsStuck, getBeeStingerCooldown, getBeeStingersInBody, getCanPickupItems, getCategory, getCollidableExemptions, getDeathSound, getDrinkingSound, getEatingSound, getEyeHeight, getEyeHeight, getEyeLocation, getFallDamageSound, getFallDamageSoundBig, getFallDamageSoundSmall, getHandRaised, getHandRaisedTime, getHurtDirection, getHurtSound, getItemUseRemainingTime, getKiller, getLastDamage, getLastTwoTargetBlocks, getLeashHolder, getLineOfSight, getMaximumAir, getMaximumNoDamageTicks, getMemory, getNoDamageTicks, getPotionEffect, getRemainingAir, getRemoveWhenFarAway, getShieldBlockingDelay, getTargetBlock, getTargetBlock, getTargetBlock, getTargetBlockExact, getTargetBlockExact, getTargetBlockFace, getTargetBlockFace, getTargetBlockInfo, getTargetBlockInfo, getTargetEntity, getTargetEntity, getTargetEntityInfo, getTargetEntityInfo, hasAI, hasLineOfSight, hasLineOfSight, hasPotionEffect, isClimbing, isCollidable, isGliding, isHandRaised, isInvisible, isJumping, isLeashed, isRiptiding, isSleeping, isSwimming, knockback, playPickupItemAnimation, playPickupItemAnimation, rayTraceBlocks, rayTraceBlocks, removePotionEffect, setAI, setArrowCooldown, setArrowsInBody, setArrowsStuck, setBeeStingerCooldown, setBeeStingersInBody, setCanPickupItems, setCollidable, setGliding, setHurtDirection, setInvisible, setJumping, setKiller, setLastDamage, setLeashHolder, setMaximumAir, setMaximumNoDamageTicks, setMemory, setNoDamageTicks, setRemainingAir, setRemoveWhenFarAway, setShieldBlockingDelay, setSwimming, swingHand, swingMainHand, swingOffHand`

### Methods inherited from interface org.bukkit.loot.Lootable

`clearLootTable, getLootTable, getSeed, hasLootTable, setLootTable, setLootTable, setSeed`

### Methods inherited from interface org.bukkit.metadata.Metadatable

`getMetadata, hasMetadata, removeMetadata, setMetadata`

### Methods inherited from interface org.bukkit.entity.Mob

`getAmbientSound, getEquipment, getHeadRotationSpeed, getMaxHeadPitch, getPathfinder, getTarget, isAware, isInDaylight, isLeftHanded, lookAt, lookAt, lookAt, lookAt, lookAt, lookAt, setAware, setLeftHanded, setTarget`

### Methods inherited from interface org.bukkit.Nameable

`customName, customName, getCustomName, setCustomName`

### Methods inherited from interface org.bukkit.permissions.Permissible

`addAttachment, addAttachment, addAttachment, addAttachment, getEffectivePermissions, hasPermission, hasPermission, isPermissionSet, isPermissionSet, permissionValue, permissionValue, recalculatePermissions, removeAttachment`

### Methods inherited from interface org.bukkit.persistence.PersistentDataHolder

`getPersistentDataContainer`

### Methods inherited from interface net.kyori.adventure.pointer.Pointered

`get, getOrDefault, getOrDefaultFrom, pointers`

### Methods inherited from interface org.bukkit.projectiles.ProjectileSource

`launchProjectile, launchProjectile, launchProjectile`

### Methods inherited from interface org.bukkit.permissions.ServerOperator

`isOp, setOp`

## Method Details

### canDuplicate

boolean canDuplicate()
Gets if the allay can duplicate.
Note: Duplication is based when the `getDuplicationCooldown()` its lower than zero.

Returns:
  if the allay can duplicate itself.

### setCanDuplicate

void setCanDuplicate(boolean canDuplicate)
Sets if the allay can duplicate.
Note: this value can be overridden later by `getDuplicationCooldown()` if is lower than zero. You can also use `setDuplicationCooldown(long)` to allow the allay to duplicate

Parameters:
  `canDuplicate` - if the allay can duplicate itself

### getDuplicationCooldown

long getDuplicationCooldown()
Gets the cooldown for duplicating the allay.

Returns:
  the time in ticks when allay can duplicate

### setDuplicationCooldown

void setDuplicationCooldown(long cooldown)
Sets the cooldown before the allay can duplicate again.

Parameters:
  `cooldown` - the cooldown, use a negative number to deny allay to duplicate again.

### resetDuplicationCooldown

void resetDuplicationCooldown()
Reset the cooldown for duplication. This will set the cooldown ticks to the same value as is set after an Allay has duplicated.

### isDancing

boolean isDancing()
Gets if the allay is dancing.

Returns:
  `True` if it is dancing, false otherwise.

### startDancing

void startDancing(@NotNull @NotNull Location location)
Causes the allay to start dancing because of the provided jukebox location.

Parameters:
  `location` - the location of the jukebox
Throws:
  `IllegalArgumentException` - if the block at the location is not a jukebox

### startDancing

void startDancing()
Force sets the dancing status of the allay.
Note: This method forces the allay to dance, ignoring any nearby jukebox being required.

### stopDancing

void stopDancing()
Makes the allay stop dancing.

### duplicateAllay

@Nullable @Nullable Allay duplicateAllay()
This make the current allay duplicate itself without dance or item necessary. Note: this will fire a `CreatureSpawnEvent`

Returns:
  the new entity `Allay` or null if the spawn was cancelled

### getJukebox

@Nullable @Nullable Location getJukebox()
Gets the jukebox the allay is set to dance to.

Returns:
  the location of the jukebox to dance if it exists